
TYPE HighScoresType                       'Type For Scores
  Ran AS INTEGER                          'Rank
  Dat AS STRING * 8                       'Date
  Nam AS STRING * 20                      'Name
  Wav AS SINGLE                           'Wave
  Scr AS LONG                             'Score
END TYPE                                  'End Type

DECLARE SUB BackGround (Mode)
DECLARE SUB DoReset (Mode, AlienNumber)
DECLARE SUB Errors (Code!)
DECLARE SUB GameMouse (GY%, GX%, Button%)
DECLARE SUB GetAlien ()
DECLARE SUB GetHighScores ()
DECLARE SUB GetLevel ()
DECLARE SUB HoldOn (Seconds)
DECLARE SUB KeyCheck (Key$)
DECLARE SUB KillAlien ()
DECLARE SUB LoadWave ()
DECLARE SUB MoveAlien ()
DECLARE SUB MousePointer (Comm)
DECLARE SUB OptButton (X1, Y1, X2, Y2, IO, Fill)
DECLARE SUB Options ()
DECLARE SUB OptionScreen ()
DECLARE SUB OptMouse (Y%, X%, Button%)
DECLARE SUB Pix5x7Font (PX, PY, Text$, Colour)
DECLARE SUB Pix3x5Nums (WX, WY, PX, PY, Num, Colour, Title)
DECLARE SUB RemAlien ()
DECLARE SUB SaveWave ()
DECLARE SUB Setup ()
DECLARE SUB ShowHighScores (Mode, TileNo)
DECLARE SUB SoundFx (Fx%)
DECLARE SUB SwBomb ()
DECLARE SUB TileBackGround (Number!)
DECLARE SUB TitleScreen ()

DECLARE FUNCTION Event ()
DECLARE FUNCTION GetNumber% (Limit%)
DECLARE FUNCTION GetWaveNo% (File%)
DECLARE FUNCTION InputText$ (X, Y, Length)

COMMON SHARED CH1X%, CH1Y%, CH2X%, CH2Y%, LBMX%, LBMY%, NBMX%, NBMY%
COMMON SHARED SWAX%, SWAY%, AlienW
COMMON SHARED AlienC1, AlienC2, AlienL, AlienB, Aliens, Speed!, TotAliens
COMMON SHARED AOS, AOSLimit, Energy, GunNo, GX%, GXShadow%, Score&, Wave
COMMON SHARED ActivB, ActivF, ActivH, ActivL, Fire, Shield, SBomb, Slow
COMMON SHARED Difficulty!, SoundMode!, Sw, Selec%, Contr%

CONST Backspace = 8                       'Set Key Values
CONST Enter = 13
CONST Esc = 27
CONST Space = 32

CONST False = 0                           'Set Other Values
CONST True = 1
CONST XMin = 60
CONST XMax = 310
CONST YMin = 20
CONST YMax = 195

DIM SHARED Beam2(4, 168) AS INTEGER       'Graphic Arrays (2D)
DIM SHARED Beam3(8, 166) AS INTEGER
DIM SHARED Beam10(10, 160) AS INTEGER
DIM SHARED Beam21(21, 169) AS INTEGER
DIM SHARED BombLaser(7, 138)  AS INTEGER
DIM SHARED Chaser1(8, 14) AS INTEGER
DIM SHARED Chaser2(5, 14) AS INTEGER
DIM SHARED Gun(10, 6) AS INTEGER
DIM SHARED LBomb(15, 17) AS INTEGER
DIM SHARED Lightening(40, 151) AS INTEGER
DIM SHARED NBomb(17, 13) AS INTEGER
DIM SHARED Shld(253, 9) AS INTEGER
DIM SHARED Swarmer(8, 8) AS INTEGER
DIM SHARED XPlode(16, 14) AS INTEGER

DIM SHARED Mice(9) AS INTEGER             'Array for Mouse code
DIM SHARED HighScores(1 TO 10) AS HighScoresType

CLS
CHDIR "C:\QB\SPACE2"                      'Change Directory
LOCATE 10, 35: PRINT "Please Wait"        'The next few things take a while

DIM SHARED WaveFile(20, 4)                'Set up titles
FOR Y = 0 TO 4                            'Top to Bottom
  FOR X = 0 TO 20                         'Left to Right
    READ Dat                              'Read Data
    WaveFile(X, Y) = Dat                  'Store Data
    LOCATE 1, 1                           'Show how long left
    PRINT USING "Setting up Titles ###% Complete"; Y * 100 \ 4
  NEXT
NEXT

DIM SHARED Nums(9, 2, 5)                  'Set up 3x5 Numbers
FOR Adress = 0 TO 9                       'Count Numbers
  FOR Y = 0 TO 4                          'Top to Bottom
    FOR X = 0 TO 2                        'Left to Right
      READ Dat                            'Read Data
      Nums(Adress, X, Y) = Dat            'Store Data
      LOCATE 2, 1                         'Show how long left
      PRINT USING "Setting up Numbers ###% Complete"; Adress * 100 \ 9
    NEXT
  NEXT
NEXT

DIM SHARED Font(126, 4, 6)                'Set up 5x7 Fonts
FOR Adress = 0 TO 126                     'Count Characters
  FOR Y = 0 TO 6                          'Top to Bottom
    FOR X = 0 TO 4                        'Left to Right
      READ Dat                            'Read Data
      Font(Adress, X, Y) = Dat            'Store Data
      LOCATE 3, 1                         'Show how long left
      PRINT USING "Setting up Fonts ###% Complete"; Adress * 100 \ 126
    NEXT
  NEXT
NEXT

OPEN "SPACE2.OPT" FOR BINARY AS #1        'Check to see if .OPT exists
  Length = LOF(1)
CLOSE #1

IF Length = 0 THEN                        'If .OPT Doesn't exist
  OPEN "SPACE2.OPT" FOR OUTPUT AS #1
    SoundMode! = -1: Difficulty! = 1      'Set new values
    WRITE #1, SoundMode!, Difficulty!     'Save new values
  CLOSE #1
END IF

ON ERROR GOTO DataFileIncorrect           'Set an error trap for .DAT file
  OPEN "SPACE2.DAT" FOR RANDOM AS #1      'Open .DAT File
    GET #1, 1, CheckLine$                 'See if first line is correct
    IF CheckLine$ <> "bm2,168c53h2u160br4d160g2" THEN CALL Errors(2)
  CLOSE #1                                'Close .DAT File
ON ERROR GOTO 0                           'End error trap

RANDOMIZE TIMER                           'Seed Random number generator

HoldOn 1                                  'Wait
SCREEN 13                                 'Set Screen mode
Wave = 1                                  'Level
Setup                                     'Enemy Setup
TitleScreen                               'Title Screen
TileBackGround (GetNumber%(9))            'Colour Screen

DEF SEG = VARSEG(Mice(0))                 'Get Mouse array segment
FOR M = 0 TO 17                           'Count Data
  READ Dat                                'Read Data
  POKE VARPTR(Mice(0)) + M, Dat           'Set up Mouse
NEXT M

OptionScreen                              'Options Screen
CALL MousePointer(0)                      'Reset mouse
CALL MousePointer(3)                      'Get coordinates

DO                                        'First Loop
  Energy = 50                             'Energy
  Sw = False                              'Assume no special weapon
  CLS                                     'Clear Screen
  GetLevel                                'Get Level
  Aliens = TotAliens                      'Number of Aliens
  BackGround 0                            'Get Background
  CALL GameMouse(GY%, GX%, Button%)       'Get Mouse
  DO                                      'Second Loop
    RemAlien                              'Remove Alien
    GetAlien                              'Get Alien
    PUT (GX%, GY%), Gun, PSET             'Draw Gun
    DO                                    'Third Loop
      GetAlien                            'Get Alien
      GXShadow% = GX%                     'Shadow Mouse
      CALL GameMouse(GY%, GX%, Button%)   'Get Mouse
      Inpt = Event                        'Get Key
      MoveAlien                           'Move Alien
      HoldOn Speed!                       'Wait

      IF Energy <= 0 THEN                 'Check for dead
        CLS
        Pix5x7Font 130, 90, "Game Over", 4'Tell the user what has happened
        SoundFx 2                         'Game Over Sound
        GetHighScores                     'Get the HighScores
        ShowHighScores 0, GetNumber(10)   'Show HighScores
        DO: LOOP UNTIL Event              'Wait until a key is pressed
        RUN                               'Re-Start Game
      END IF

    LOOP UNTIL GXShadow% <> GX% OR Button% <> 0 OR Inpt
    IF Inpt THEN KeyCheck (STR$(Inpt))    'Convert key to String, Read it
    RemAlien                              'Remove Alien.... Draw Shield?
    IF ActivH = True THEN PUT (XMin + 1, 160), Shld, PSET
    IF ActivB = True THEN SwBomb          'Draw Explosion?

    PUT (GXShadow%, GY%), Gun             'Remove Gun
    PUT (GX%, GY%), Gun, PSET             'Draw Gun
    SELECT CASE Button%                   'Check for pressed button
      CASE 1: KillAlien                   'Check for killing
      CASE 2                              'Options
        HoldOn .1                         'Wait
        CALL MousePointer(0)              'Reset mouse
        CALL MousePointer(3)              'Get coordinates
        Options                           'Main Options
        CALL MousePointer(0)              'Reset mouse
        CALL MousePointer(3)              'Get coordinates
        HoldOn 1                          'Wait
    END SELECT
  LOOP UNTIL Aliens <= 0

  CLS
  Wave = Wave + 1                         'Increase Wave
  IF Energy >= 50 AND Sw = False THEN     'Get Bonus?
    Bonus = 1000                          'Set Bonus
    Score& = Score& + Bonus               'Add Bonus.... Random Numbers
    Num1 = GetNumber(3): Num2 = GetNumber(3)
    Num3 = GetNumber(3): Num4 = GetNumber(3)

    LINE (4, 64)-(16, 76), 104, BF        'Show what special items
    DRAW "bm6,70c74e2r3f2bd3h2l3g2"       'user has won
    Pix5x7Font 20, 67, STR$(Num1), 74
    Shield = Shield + Num1

    LINE (4, 86)-(16, 98), 104, BF
    DRAW "bm5,88c53f2r6e2bg2d4f2bh2l6g2be2u4br2bdp53,53buc254d4br2u4"
    Pix5x7Font 20, 89, STR$(Num2), 53
    SBomb = SBomb + Num2

    LINE (4, 108)-(16, 120), 104, BF
    DRAW "bm5,110c15r3d4bu2l3d2bu2u2bd10e10bd5bl3r3d2l3d2r3"
    Pix5x7Font 20, 111, STR$(Num3), 15
    Slow = Slow + Num3

    LINE (4, 130)-(16, 142), 104, BF
    DRAW "bm7,141c42u5eueuefdfdfd5l5bup42,42c14bdu4euefdfd4l4br2bup14,14"
    Pix5x7Font 20, 133, STR$(Num4), 42
    Fire = Fire + Num4

  ELSE                                    'No Bonus
    Bonus = 0
  END IF

  Pix5x7Font 130, 90, "Bonus", 15         'Show Bonus
  Pix5x7Font 130 + 36, 90, STR$(Bonus), 15
  Pix5x7Font 120, 100, "Attack Wave", 15  'Show Level
  Pix5x7Font 120 + 72, 100, STR$(Wave), 15
  Pix5x7Font 130, 110, "Score", 15        'Show Score
  Pix5x7Font 130 + 36, 110, STR$(Score&), 15
  Pix5x7Font 100, 180, "Press any key to Continue", 69
  DoReset 0, 0                            'Total Reset

  DO: LOOP UNTIL Event                    'Wait until user responds

  IF ActivB = True THEN ActivB = False    'Remove Special Weapons
  IF ActivF = True THEN ActivF = False
  IF ActivH = True THEN ActivH = False
  IF ActivL = True THEN ActivL = False

LOOP

'WAVE
DATA 1,0,0,0,1,0,1,1,1,1,0,1,0,0,0,1,0,1,1,1,1
DATA 1,0,0,0,1,0,1,0,0,1,0,1,0,0,0,1,0,1,0,0,0
DATA 1,0,0,0,1,0,1,1,1,1,0,0,1,0,1,0,0,1,1,1,0
DATA 1,0,1,0,1,0,1,0,0,1,0,0,1,0,1,0,0,1,0,0,0
DATA 1,1,0,1,1,0,1,0,0,1,0,0,0,1,0,0,0,1,1,1,1
'0
DATA 1,1,1
DATA 1,0,1
DATA 1,0,1
DATA 1,0,1
DATA 1,1,1
'1
DATA 0,1,0
DATA 0,1,0
DATA 0,1,0
DATA 0,1,0
DATA 0,1,0
'2
DATA 1,1,1
DATA 0,0,1
DATA 1,1,1
DATA 1,0,0
DATA 1,1,1
'3
DATA 1,1,1
DATA 0,0,1
DATA 1,1,1
DATA 0,0,1
DATA 1,1,1
'4
DATA 1,0,1
DATA 1,0,1
DATA 1,1,1
DATA 0,0,1
DATA 0,0,1
'5
DATA 1,1,1
DATA 1,0,0
DATA 1,1,1
DATA 0,0,1
DATA 1,1,1
'6
DATA 1,1,1
DATA 1,0,0
DATA 1,1,1
DATA 1,0,1
DATA 1,1,1
'7
DATA 1,1,1
DATA 0,0,1
DATA 0,0,1
DATA 0,0,1
DATA 0,0,1
'8
DATA 1,1,1
DATA 1,0,1
DATA 1,1,1
DATA 1,0,1
DATA 1,1,1
'9
DATA 1,1,1
DATA 1,0,1
DATA 1,1,1
DATA 0,0,1
DATA 1,1,1


                                          'Data For Fonts  0 - 127
'0 Nul
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
'1
DATA 0,0,0,0,0
DATA 0,1,0,1,0
DATA 0,1,0,1,0
DATA 0,0,0,0,0
DATA 0,1,0,1,0
DATA 0,1,1,1,0
DATA 0,0,0,0,0
'2
DATA 1,1,1,1,1
DATA 1,0,1,0,1
DATA 1,0,1,0,1
DATA 1,1,1,1,1
DATA 1,0,1,0,1
DATA 1,0,0,0,1
DATA 1,1,1,1,1
'3
DATA 0,0,0,0,0
DATA 0,1,0,1,0
DATA 1,1,1,1,1
DATA 1,1,1,1,1
DATA 0,1,1,1,0
DATA 0,0,1,0,0
DATA 0,0,0,0,0
'4
DATA 0,0,0,0,0
DATA 0,0,1,0,0
DATA 0,1,1,1,0
DATA 1,1,1,1,1
DATA 1,1,1,1,1
DATA 0,1,1,1,0
DATA 0,0,1,0,0
'5
DATA 0,1,1,1,0
DATA 0,1,1,1,0
DATA 1,1,1,1,1
DATA 1,1,1,1,1
DATA 1,1,1,1,1
DATA 0,0,1,0,0
DATA 0,0,1,0,0
'6
DATA 0,0,1,0,0
DATA 0,1,1,1,0
DATA 1,1,1,1,1
DATA 1,1,0,1,1
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,0,0,0
'7
DATA 0,0,0,0,0
DATA 0,0,1,0,0
DATA 0,1,1,1,0
DATA 0,1,1,1,0
DATA 0,1,1,1,0
DATA 0,0,1,0,0
DATA 0,0,0,0,0
'8
DATA 1,1,1,1,1
DATA 1,1,0,1,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,1,0,1,1
DATA 1,1,1,1,1
'9
DATA 0,0,0,0,0
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,0
DATA 0,0,0,0,0
'10
DATA 1,1,1,1,1
DATA 1,0,0,0,1
DATA 0,1,1,1,0
DATA 0,1,1,1,0
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,1,1,1,1
'11
DATA 0,0,1,1,1
DATA 0,0,0,1,1
DATA 0,0,1,0,1
DATA 0,1,1,0,0
DATA 1,0,0,1,0
DATA 1,0,0,1,0
DATA 0,1,1,0,0
'12
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,0
DATA 0,0,1,0,0
DATA 0,1,1,1,0
DATA 0,0,1,0,0
'13
DATA 0,0,1,1,1
DATA 0,0,1,0,0
DATA 0,0,1,1,0
DATA 0,0,1,0,0
DATA 1,1,1,0,0
DATA 1,1,1,0,0
DATA 1,1,1,0,0
'14
DATA 1,1,1,1,1
DATA 1,0,0,0,1
DATA 1,1,1,1,1
DATA 0,1,0,0,1
DATA 1,1,0,0,1
DATA 1,1,0,1,1
DATA 0,0,0,1,1
'15
DATA 1,0,1,0,1
DATA 0,1,1,1,0
DATA 0,1,0,1,0
DATA 1,1,0,1,1
DATA 0,1,0,1,0
DATA 0,1,1,1,0
DATA 1,0,1,0,1
'16
DATA 1,1,0,0,0
DATA 1,1,1,0,0
DATA 1,1,1,1,0
DATA 1,1,1,1,1
DATA 1,1,1,1,0
DATA 1,1,1,0,0
DATA 1,1,0,0,0
'17
DATA 0,0,0,1,1
DATA 0,0,1,1,1
DATA 0,1,1,1,1
DATA 1,1,1,1,1
DATA 0,1,1,1,1
DATA 0,0,1,1,1
DATA 0,0,0,1,1
'18
DATA 0,0,1,0,0
DATA 0,1,1,1,0
DATA 1,0,1,0,1
DATA 0,0,1,0,0
DATA 1,0,1,0,1
DATA 0,1,1,1,0
DATA 0,0,1,0,0
'19
DATA 0,1,0,1,0
DATA 0,1,0,1,0
DATA 0,1,0,1,0
DATA 0,1,0,1,0
DATA 0,1,0,1,0
DATA 0,0,0,0,0
DATA 0,1,0,1,0
'20
DATA 1,1,1,1,1
DATA 1,1,0,1,0
DATA 1,1,0,1,0
DATA 0,1,0,1,0
DATA 0,1,0,1,0
DATA 0,1,0,1,0
DATA 0,1,0,1,0
'21
DATA 0,0,1,1,0
DATA 0,1,0,0,1
DATA 0,0,1,0,0
DATA 0,0,0,1,0
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 1,1,1,1,0
'22
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,1,1,1,1
DATA 1,1,1,1,1
'23
DATA 0,0,1,0,0
DATA 0,1,1,1,0
DATA 1,0,1,0,1
DATA 1,0,1,0,1
DATA 0,1,1,1,0
DATA 0,0,1,0,0
DATA 1,1,1,1,1
'24
DATA 0,0,1,0,0
DATA 0,1,1,1,0
DATA 1,0,1,0,1
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
'25
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 1,0,1,0,1
DATA 0,1,1,1,0
DATA 0,0,1,0,0
'26
DATA 0,0,0,0,0
DATA 0,0,1,0,0
DATA 0,0,0,1,0
DATA 1,1,1,1,1
DATA 0,0,0,1,0
DATA 0,0,1,0,0
DATA 0,0,0,0,0
'27
DATA 0,0,0,0,0
DATA 0,0,1,0,0
DATA 0,1,0,0,0
DATA 1,1,1,1,1
DATA 0,1,0,0,0
DATA 0,0,1,0,0
DATA 0,0,0,0,0
'28
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,0,0,0,0
DATA 1,1,1,1,1
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
'29
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,1,0,1,0
DATA 1,1,1,1,1
DATA 0,1,0,1,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
'30
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,1,0,0
DATA 0,1,1,1,0
DATA 1,1,1,1,1
'31
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,1,1,1,1
DATA 0,1,1,1,0
DATA 0,0,1,0,0
'32 Space
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
'33
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 0,0,0,0,0
DATA 1,0,0,0,0
'34
DATA 0,1,0,1,0
DATA 0,1,0,1,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
'35
DATA 0,1,0,1,0
DATA 0,1,0,1,0
DATA 1,1,1,1,1
DATA 0,1,0,1,0
DATA 1,1,1,1,1
DATA 0,1,0,1,0
DATA 0,1,0,1,0
'36
DATA 0,0,1,0,0
DATA 0,1,1,1,1
DATA 1,0,0,0,0
DATA 0,1,1,1,0
DATA 0,0,0,0,1
DATA 1,1,1,1,0
DATA 0,0,1,0,0
'37
DATA 1,1,0,0,0
DATA 1,1,0,0,1
DATA 0,0,0,1,0
DATA 0,0,1,0,0
DATA 0,1,0,0,0
DATA 1,0,0,1,1
DATA 0,0,0,1,1
'38
DATA 0,1,1,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 0,1,0,0,0
DATA 1,0,1,1,0
DATA 1,0,1,1,0
DATA 0,1,0,0,1
'39
DATA 0,1,0,0,0
DATA 1,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
'40
DATA 0,1,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 0,1,0,0,0
'41
DATA 1,0,0,0,0
DATA 0,1,0,0,0
DATA 0,1,0,0,0
DATA 0,1,0,0,0
DATA 0,1,0,0,0
DATA 0,1,0,0,0
DATA 1,0,0,0,0
'42
DATA 0,0,0,0,0
DATA 1,0,1,0,1
DATA 0,1,1,1,0
DATA 1,1,1,1,1
DATA 0,1,1,1,0
DATA 1,0,1,0,1
DATA 0,0,0,0,0
'43
DATA 0,0,0,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 1,1,1,1,1
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,0,0,0
'44
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,1,0,0,0
DATA 1,0,0,0,0
'45
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,1,1,1,1
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
'46
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,0,0,0,0
'47
DATA 0,0,0,0,0
DATA 0,0,0,0,1
DATA 0,0,0,1,0
DATA 0,0,1,0,0
DATA 0,1,0,0,0
DATA 1,0,0,0,0
DATA 0,0,0,0,0
'48
'Numbers
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,0
'49
DATA 0,1,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,1,1,1,0
'50
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 0,0,0,1,0
DATA 0,0,1,0,0
DATA 0,1,0,0,0
DATA 1,0,0,0,0
DATA 1,1,1,1,1
'51
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 0,0,0,0,1
DATA 0,1,1,1,0
DATA 0,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,0
'52
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
'53
DATA 1,1,1,1,1
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,1,1,1,0
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 1,1,1,1,0
'54
DATA 0,1,1,1,1
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,0
'55
DATA 1,1,1,1,0
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
'56
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,0
'57
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
'58
DATA 0,0,0,0,0
DATA 0,0,1,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,1,0,0
DATA 0,0,0,0,0
'59
DATA 0,0,0,0,0
DATA 0,0,1,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,1,0,0
DATA 0,1,0,0,0
'60
DATA 0,0,0,0,0
DATA 0,0,0,1,0
DATA 0,0,1,0,0
DATA 0,1,0,0,0
DATA 0,0,1,0,0
DATA 0,0,0,1,0
DATA 0,0,0,0,0
'61
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,1,1,1,1
DATA 0,0,0,0,0
DATA 1,1,1,1,1
DATA 0,0,0,0,0
DATA 0,0,0,0,0
'62
DATA 0,0,0,0,0
DATA 0,1,0,0,0
DATA 0,0,1,0,0
DATA 0,0,0,1,0
DATA 0,0,1,0,0
DATA 0,1,0,0,0
DATA 0,0,0,0,0
'63
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 0,0,0,0,1
DATA 0,0,0,1,0
DATA 0,0,1,0,0
DATA 0,0,0,0,0
DATA 0,0,1,0,0
'64
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,1,0,1
DATA 1,0,1,1,1
DATA 1,0,0,0,0
DATA 1,0,0,0,1
DATA 0,1,1,1,0
'65 Capitol
DATA 1,1,1,1,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,1,1,1,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
'66
DATA 1,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,1,1,1,0
'67
DATA 0,1,1,1,1
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 0,1,1,1,1
'68
DATA 1,1,1,1,0
DATA 0,1,0,0,1
DATA 0,1,0,0,1
DATA 0,1,0,0,1
DATA 0,1,0,0,1
DATA 0,1,0,0,1
DATA 1,1,1,1,0
'69
DATA 1,1,1,1,1
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,1,1,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,1,1,1,1
'70
DATA 1,1,1,1,1
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,1,1,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
'71
DATA 0,1,1,1,1
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,1,1,1
DATA 1,0,1,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,0
'72
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,1,1,1,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
'73
DATA 1,1,1,1,1
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 1,1,1,1,1
'74
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 1,0,0,0,1
DATA 1,1,1,1,1
'75
DATA 1,0,0,0,1
DATA 1,0,0,1,0
DATA 1,0,1,0,0
DATA 1,1,0,0,0
DATA 1,0,1,0,0
DATA 1,0,0,1,0
DATA 1,0,0,0,1
'76
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,1,1,1,1
'77
DATA 1,1,1,1,1
DATA 1,0,1,0,1
DATA 1,0,1,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
'78
DATA 1,1,1,1,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
'79
DATA 1,1,1,1,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,1,1,1,1
'80
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,1,1,1,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
'81
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,1,1
DATA 0,1,1,1,1
'82
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,1,1,1,0
DATA 1,1,0,0,0
DATA 1,0,1,0,0
DATA 1,0,0,1,1
'83
DATA 0,1,1,1,1
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 0,1,1,1,0
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 1,1,1,1,0
'84
DATA 1,1,1,1,1
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
'85
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,1,1,1,1
'86
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,0,1,0
DATA 0,1,0,1,0
DATA 0,0,1,0,0
'87
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,1,0,1
DATA 1,0,1,0,1
DATA 1,1,0,1,1
'88
DATA 1,0,0,0,1
DATA 0,1,0,1,0
DATA 0,1,0,1,0
DATA 0,0,1,0,0
DATA 0,1,0,1,0
DATA 0,1,0,1,0
DATA 1,0,0,0,1
'89
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,0,1,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
'90
DATA 1,1,1,1,1
DATA 0,0,0,0,1
DATA 0,0,0,1,0
DATA 0,0,1,0,0
DATA 0,1,0,0,0
DATA 1,0,0,0,0
DATA 1,1,1,1,1
'91
DATA 0,1,1,1,0
DATA 0,1,0,0,0
DATA 0,1,0,0,0
DATA 0,1,0,0,0
DATA 0,1,0,0,0
DATA 0,1,0,0,0
DATA 0,1,1,1,0
'92
DATA 0,0,0,0,0
DATA 1,0,0,0,0
DATA 0,1,0,0,0
DATA 0,0,1,0,0
DATA 0,0,0,1,0
DATA 0,0,0,0,1
DATA 0,0,0,0,0
'93
DATA 0,1,1,1,0
DATA 0,0,0,1,0
DATA 0,0,0,1,0
DATA 0,0,0,1,0
DATA 0,0,0,1,0
DATA 0,0,0,1,0
DATA 0,1,1,1,0
'94
DATA 0,0,1,0,0
DATA 0,1,0,1,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
'95
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,1,1,1,1
'96
DATA 0,0,1,0,0
DATA 0,0,0,1,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
'97 Lower case
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,1,1
DATA 0,1,1,1,1
'98
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,1,1,1,0
'99
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,1,1,1,1
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 0,1,1,1,1
'100
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 0,1,1,1,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,1
'101
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,1,1,1,0
DATA 1,0,0,0,0
DATA 0,1,1,1,1
'102
DATA 0,0,1,1,1
DATA 0,1,0,0,0
DATA 1,1,1,1,0
DATA 0,1,0,0,0
DATA 0,1,0,0,0
DATA 0,1,0,0,0
DATA 0,1,0,0,0
'103
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 1,1,1,1,0
'104
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,1,1,1,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
'105
DATA 0,0,1,0,0
DATA 0,0,0,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
'106
DATA 0,0,0,1,0
DATA 0,0,0,0,0
DATA 0,0,0,1,0
DATA 0,0,0,1,0
DATA 0,0,0,1,0
DATA 0,0,0,1,0
DATA 1,1,1,1,0
'107
DATA 0,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,1
DATA 1,0,0,1,0
DATA 1,1,1,0,0
DATA 1,0,0,1,0
DATA 1,0,0,0,1
'108
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,1,0,0,0
'109
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,1,0,1,1
DATA 1,0,1,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
'110
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,1,1,1,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
'111
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,0
'112
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,1,1,1,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
'113
DATA 0,1,1,1,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
'114
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,1,1,1,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
DATA 1,0,0,0,0
'115
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,1,1,1,1
DATA 1,0,0,0,0
DATA 0,1,1,1,0
DATA 0,0,0,0,1
DATA 1,1,1,1,0
'116
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 1,1,1,1,1
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,1,0
'117
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,0
'118
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,0,1,0
DATA 0,1,0,1,0
DATA 0,0,1,0,0
'119
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,1,0,1
DATA 1,1,0,1,1
'120
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,0,0,0,1
DATA 0,1,0,1,0
DATA 0,0,1,0,0
DATA 0,1,0,1,0
DATA 1,0,0,0,1
'121
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 1,0,0,0,1
DATA 0,1,1,1,1
DATA 0,0,0,0,1
DATA 0,0,0,0,1
DATA 1,1,1,1,0
'122
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 1,1,1,1,1
DATA 0,0,0,1,0
DATA 0,0,1,0,0
DATA 0,1,0,0,0
DATA 1,1,1,1,1
'123
DATA 0,0,1,0,0
DATA 0,1,0,0,0
DATA 0,1,0,0,0
DATA 1,0,0,0,0
DATA 0,1,0,0,0
DATA 0,1,0,0,0
DATA 0,0,1,0,0
'124
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,0,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
DATA 0,0,1,0,0
'125
DATA 0,0,1,0,0
DATA 0,0,0,1,0
DATA 0,0,0,1,0
DATA 0,0,0,0,1
DATA 0,0,0,1,0
DATA 0,0,0,1,0
DATA 0,0,1,0,0
'126
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0
DATA 0,0,1,0,1
DATA 0,1,0,1,0
DATA 0,0,0,0,0
DATA 0,0,0,0,0

'Data For Mouse
DATA &HB8,&H00,&H00
DATA &H55
DATA &H8B,&HEC
DATA &HCD,&H33
DATA &H92
DATA &H8B,&H5E,&H06
DATA &H89,&H07
DATA &H5D
DATA &HCA,&H02,&H00


'DATA to replace .SCR if it is deleted
DATA 1, 23/04/98, IVAN WRIGHT, 60, 9000000
DATA 2, 23/04/98, SPACE FIGHTER 3D, 10, 9000
DATA 3, 23/04/98, WILL BE COMING , 9, 8000
DATA 4, 23/04/98, OUT IN 2-3 YEARS, 8, 7000
DATA 5, 23/04/98, IT WILL BE ,8 , 6000
DATA 6, 23/04/98, WRITTEN IN C++, 8, 5000
DATA 7, 23/04/98, BLANK LINE, 7, 4000
DATA 8, 23/04/98, MORE INFO IN THE, 5, 3000
DATA 9, 23/04/98, HELP FILE, 3, 2000
DATA 10, 23/04/98, GOOD BYE, 2, 1000

DataFileIncorrect: CALL Errors(2)

SUB BackGround (Mode)
  LINE (XMin, YMin)-(XMax + 5, YMax), 73, B
  LINE (XMin, 0)-(XMax + 5, 9), 0, BF     'Delete Energy
  Pix5x7Font 25, 0, "Energy", 2
  LINE (XMin, 1)-(XMax + 5, 8), 2, B      'New Box for Energy

  FOR EL = 60 TO 315 STEP 5               'Count Energy blocks
    LINE (EL, 1)-(EL, 8), 2               'Draw Line
  NEXT

  I = 63                                  'Set starting place
  FOR J = 0 TO Energy                     'Count Energy
    PAINT (I, 4), 10, 2                   'Paint Energy
    I = I + 5
  NEXT
  IF Mode THEN EXIT SUB                   'End Background?

  Pix5x7Font 10, 10, STR$(Score&), 15     'Write Information
  Pix5x7Font 20, 40, STR$(Aliens), 15
  Pix5x7Font 0, 50, "Wave", 15
  Pix5x7Font 20, 50, STR$(Wave), 15
  DRAW "bm6,48c4u8r7d8l7br2bu2r3u2l3u2r3"

  CALL OptButton(4, 64, 16, 76, 1, 1)     'Draw Button
  DRAW "bm6,70c74e2r3f2bd3h2l3g2"         'Draw Picture
  Pix5x7Font 20, 67, STR$(Shield), 74     'Number of Shield's

  CALL OptButton(4, 86, 16, 98, 1, 1)     'Draw Button.... Draw Picture
  DRAW "bm5,88c53f2r6e2bg2d4f2bh2l6g2be2u4br2bdp53,53buc254d4br2u4"
  Pix5x7Font 20, 89, STR$(SBomb), 53      'Number of Bomb's

  CALL OptButton(4, 108, 16, 120, 1, 1)   'Draw Button.... Draw Picture
  DRAW "bm5,110c15r3d4bu2l3d2bu2u2bd10e10bd5bl3r3d2l3d2r3"
  Pix5x7Font 20, 111, STR$(Slow), 15      'Number of Slow up's

  CALL OptButton(4, 129, 16, 142, 1, 1)   'Draw Button.... Draw Picture
  DRAW "bm7,141c42u5eueuefdfdfd5l5bup42,42c14bdu4euefdfd4l4br2bup14,14"
  Pix5x7Font 20, 133, STR$(Fire), 42      'Number of Fire Beam's

  CALL OptButton(4, 149, 32, 161, 1, 1)   'Draw Button
  Pix5x7Font 7, 153, "Save", 15           'Write Save

  CALL OptButton(4, 169, 32, 181, 1, 1)   'Draw Button
  Pix5x7Font 7, 173, "Exit", 15           'Write Save
END SUB

SUB DoReset (Mode, AlienNumber)
  IF NOT Mode THEN                        'Total Reset
    CH1X% = XMin + 1: CH1Y% = YMin + 1    'Remove Alien
    CH2X% = XMin + 1: CH2Y% = YMin + 1    'Ditto
    LBMX% = XMin + 1: LBMY% = 25          'Ditto
    NBMX% = XMin + 1: NBMY% = 40          'Ditto
    SWAX% = XMin + 1: SWAY% = YMin + 1
    AlienC1 = False: AlienC2 = False      'Ditto
    AlienL = False: AlienB = False
    AlienW = False

  ELSEIF Mode THEN                        'Not Total Reset
    SELECT CASE AlienNumber               'Select Alien to Remove
      CASE 1
        CH1X% = XMin + 1: CH1Y% = YMin + 1'Remove Alien
        AlienC1 = False
      CASE 2
        CH2X% = XMin + 1: CH2Y% = YMin + 1'Ditto
        AlienC2 = False
      CASE 3
        LBMX% = XMin + 1: LBMY% = 25      'Ditto
        AlienL = False
      CASE 4
        NBMX% = XMin + 1: NBMY% = 40      'Ditto
        AlienB = False
      CASE 5
        SWAX% = XMin + 1: SWAY% = YMin + 1'Ditto
        AlienW = False
    END SELECT
  END IF


END SUB

SUB Errors (Code!)
  CLS
  SELECT CASE Code!                       'Which Error?
    CASE 1                                'Wrong size variables in .OPT File
      PRINT "ERROR IN SPACE2.OPT!!!": HoldOn 1
      PRINT
      PRINT "DELETEING SPACE2.OPT....": HoldOn 1
      KILL "SPACE2.OPT"
      PRINT
      PRINT "RE-WRITING SPACE2.OPT....": HoldOn 1
      OPEN "SPACE2.OPT" FOR OUTPUT AS #1
        SoundMode! = -1: Difficulty! = 1
        WRITE #1, SoundMode!, Difficulty!
      CLOSE #1
      PRINT
      PRINT "RE-STARTING PROGRAM....": HoldOn 1
      HoldOn 1
      RUN
    CASE 2                                'Error in .DAT File
      PRINT "ERROR IN SPACE2.DAT": HoldOn 1
      PRINT                               'Can't correct .DAT File
      PRINT "PROGRAM ENDED": HoldOn 1
      END

  END SELECT

END SUB

FUNCTION Event
  Kee$ = INKEY$                           'Get Key

  IF Kee$ <> "" THEN
    IF LEN(Kee$) = 1 THEN                 'Check Length
      Keycode = ASC(Kee$)                 'Regular Ascii
    ELSE Keycode = -ASC(RIGHT$(Kee$, 1))  'Extended Ascii
    END IF
  END IF

  Event = Keycode                         'Return Event

END FUNCTION

SUB GameMouse (GY%, GX%, Button%)

  POKE VARPTR(Mice(4)), &H92              'Swap code, Get GY% setup
  CALL ABSOLUTE(GY%, VARPTR(Mice(0)))     'Run Code
  GY% = 188                               'Hold GY%

  POKE VARPTR(Mice(4)), &H91              'Swap code, Get GX% setup
  CALL ABSOLUTE(GX%, VARPTR(Mice(0)))     'Run Code
  GX% = GX% / 2                           'Size of Screen
  IF GX% < XMin + 1 THEN GX% = XMin + 1   'Limit GX% Movement
  IF GX% > XMax - 11 THEN GX% = XMax - 11 'Ditto

  POKE VARPTR(Mice(4)), &H93              'Swap code, Get Button% setup
  CALL ABSOLUTE(Button%, VARPTR(Mice(0))) 'Run Code

END SUB

SUB GetAlien
  IF AOS >= AOSLimit THEN EXIT SUB        'Enough Aliens?
  RndNum1 = GetNumber(2)                  'Left or Right
  RndNum2 = GetNumber(90)                 'Top or Bottom
  RndNum2 = RndNum2 + 30                  'Increase 2nd Random Number
  IF AOS < AOSLimit THEN                  'Need more Aliens?
  AlienToGet = GetNumber%(Selec%) + Contr%
  SELECT CASE AlienToGet                  'Which one?

    CASE 1                                'Chaser 1
      IF AlienC1 = False THEN             'Check to see if it exists
        AOS = AOS + 1                     'Increase AOS
        AlienC1 = True                    'Alien exists.... Set X Axis
        IF RndNum1 = 1 THEN CH1X% = XMin + 1
        IF RndNum1 = 2 THEN CH1X% = XMax - 9
        CH1Y% = RndNum2                   'Set Y Axis
        PUT (CH1X%, CH1Y%), Chaser1, PSET 'Draw Chaser 1
      END IF
    CASE 2                                'Chaser 2
      IF AlienC2 = False THEN             'Check to see if it exists
        AOS = AOS + 1                     'Increase AOS
        AlienC2 = True                    'Alien exists.... Set X Axis
        IF RndNum1 = 1 THEN CH2X% = XMin + 1
        IF RndNum1 = 2 THEN CH2X% = XMax - 6
        CH2Y% = RndNum2                   'Set Y Axis
        PUT (CH2X%, CH2Y%), Chaser2, PSET 'Draw Chaser 2
      END IF
    CASE 3                                'Swarmer
      IF AlienW = False THEN              'Check to see if it exists
        AOS = AOS + 1                     'Increse AOS
        AlienW = True                     'Alien exists.... Set X Axis
        IF RndNum1 = 1 THEN SWAX% = XMin + 1
        IF RndNum1 = 2 THEN SWAX% = XMax - 8
        SWAY% = RndNum2                   'Set Y Axis
        PUT (SWAX%, SWAY%), Swarmer, PSET 'Draw Swarmer
      END IF
    CASE 4                                'Lightening Bomber
      IF AlienB = False THEN              'Check to see if it exists
        AOS = AOS + 1                     'Increase AOS
        AlienB = True                     'Alien exists.... Set X Axis
        IF RndNum1 = 1 THEN NBMX% = XMin + 1
        IF RndNum1 = 2 THEN NBMX% = XMax - 18
        NBMY% = 40                        'Set Y Axis
        PUT (NBMX%, NBMY%), NBomb, PSET   'Draw Bomber
      END IF
    CASE 5                                'Normal Bomber
      IF AlienL = False THEN              'Check to see if it exists
        AOS = AOS + 1                     'Increase AOS
        AlienL = True                     'Alien exists.... Set X Axis
        IF RndNum1 = 1 THEN LBMX% = XMin + 1
        IF RndNum1 = 2 THEN LBMX% = XMax - 20
        LBMY% = 25                        'Set Y Axis
        PUT (LBMX%, LBMY%), LBomb, PSET   'Draw L Bomber
      END IF

  END SELECT
  END IF
END SUB

SUB GetHighScores
  OPEN "SPACE2.SCR" FOR RANDOM AS #1      'Get .SCR File
  IF LOF(1) = 0 THEN                      'If the file doesn't exist
    FOR N = 1 TO 10                       'Count Data
      READ A%, B$, C$, D!, E&             'Read Data
      HighScores(N).Ran = A%              'Store Data
      HighScores(N).Dat = B$              'Ditto
      HighScores(N).Nam = C$              'Ditto
      HighScores(N).Wav = D!              'Ditto
      HighScores(N).Scr = E&              'Ditto
      PUT #1, N, HighScores(N)            'Save Data to .SCR File
    NEXT
  END IF                                  'If the file exists
  FOR O = 1 TO 10                         'Count Data
    GET #1, O, HighScores(O)              'Read Data
  NEXT
  FOR Rank = 1 TO 10                      'Find Players Rank

    IF Score& > HighScores(Rank).Scr THEN 'Make it in?

     FOR Sort = 9 TO Rank STEP -1         'Sort HighScores
        HighScores(Sort + 1).Ran = HighScores(Sort + 1).Ran
        HighScores(Sort + 1).Dat = HighScores(Sort).Dat
        HighScores(Sort + 1).Nam = HighScores(Sort).Nam
        HighScores(Sort + 1).Wav = HighScores(Sort).Wav
        HighScores(Sort + 1).Scr = HighScores(Sort).Scr
     NEXT

     Day$ = MID$(DATE$, 4, 2)             'Get Day
     Month$ = MID$(DATE$, 1, 2)           'Get Month
     Year$ = MID$(DATE$, 9, 2)            'Get Year.... Format the date
     Format$ = Day$ + "/" + Month$ + "/" + Year$

     HighScores(Rank).Ran = Rank          'Store Rank
     HighScores(Rank).Dat = Format$       'Store Date
     HighScores(Rank).Scr = Score&        'Store Score
     HighScores(Rank).Wav = Wave          'Store Wav
     HighScores(Rank).Nam = ""            'Delete Name

     TileBackGround (GetNumber%(9))       'Colour Screen
     CALL OptButton(85, 55, 230, 90, 1, 1)'Draw a Plate.... Message
     Pix5x7Font 94, 60, "Please enter your name!", 15
     HighScores(Rank).Nam = InputText$(90, 75, 21)
     CLS
     EXIT FOR                             'Don't Sort any more
   END IF
  NEXT

  FOR I = 1 TO 10
    PUT #1, I, HighScores(I)              'Save Scores
  NEXT

  CLOSE #1                                'Close .SCR

END SUB

SUB GetLevel
  SELECT CASE Wave                        'Get level
  CASE 1: TotAliens = 12: Speed! = .07: AOSLimit = 1: GunNo = 1: Selec% = 2: Contr% = 0
  CASE 2: TotAliens = 12: Speed! = .07: AOSLimit = 1: GunNo = 1: Selec% = 2: Contr% = 0
  CASE 3: TotAliens = 14: Speed! = .06: AOSLimit = 1: GunNo = 1: Selec% = 2: Contr% = 0
    CASE 4: TotAliens = 16: Speed! = .05: AOSLimit = 1: GunNo = 1: Selec% = 2: Contr% = 0
    CASE 5: TotAliens = 16: Speed! = .04: AOSLimit = 1: GunNo = 1: Selec% = 2: Contr% = 0
    CASE 6: TotAliens = 16: Speed! = .02: AOSLimit = 1: GunNo = 1: Selec% = 2: Contr% = 0
    CASE 7: TotAliens = 18: Speed! = .02: AOSLimit = 1: GunNo = 1: Selec% = 2: Contr% = 0
    CASE 8: TotAliens = 20: Speed! = .02: AOSLimit = 1: GunNo = 1: Selec% = 2: Contr% = 0
    CASE 9: TotAliens = 22: Speed! = .02: AOSLimit = 1: GunNo = 1: Selec% = 2: Contr% = 0
    CASE 10: TotAliens = 30: Speed! = .01: AOSLimit = 2: GunNo = 2: Selec% = 3: Contr% = 0
    CASE 11: TotAliens = 32: Speed! = .01: AOSLimit = 2: GunNo = 2: Selec% = 3: Contr% = 0
    CASE 12: TotAliens = 32: Speed! = .008: AOSLimit = 2: GunNo = 2: Selec% = 3: Contr% = 0
    CASE 13: TotAliens = 34: Speed! = .006: AOSLimit = 2: GunNo = 2: Selec% = 3: Contr% = 0
    CASE 14: TotAliens = 36: Speed! = .005: AOSLimit = 2: GunNo = 2: Selec% = 3: Contr% = 0
    CASE 15: TotAliens = 36: Speed! = .004: AOSLimit = 2: GunNo = 2: Selec% = 3: Contr% = 0
    CASE 16: TotAliens = 36: Speed! = .002: AOSLimit = 2: GunNo = 2: Selec% = 3: Contr% = 0
    CASE 17: TotAliens = 38: Speed! = .002: AOSLimit = 2: GunNo = 2: Selec% = 3: Contr% = 0
    CASE 18: TotAliens = 40: Speed! = .001: AOSLimit = 2: GunNo = 2: Selec% = 3: Contr% = 0
    CASE 19: TotAliens = 40: Speed! = .001: AOSLimit = 2: GunNo = 2: Selec% = 3: Contr% = 0
    CASE 20: TotAliens = 30: Speed! = .01: AOSLimit = 2: GunNo = 10: Selec% = 3: Contr% = 2
    CASE 21: TotAliens = 35: Speed! = .01: AOSLimit = 4: GunNo = 10: Selec% = 3: Contr% = 2
    CASE IS >= 22: END

    CASE 22
      TotAliens = 35: Speed! = .01
      AOSLimit = 4: GunNo = 2
      Selec% = 3: Contr% = 2
    CASE IS >= 12: END
  END SELECT

  Speed! = Speed! * Difficulty!           'Set Difficulty
END SUB

FUNCTION GetNumber% (Limit%)

  ANum% = INT(RND * Limit%) + 1           'Random number generator

  GetNumber% = ANum%                      'Return number
END FUNCTION

FUNCTION GetWaveNo% (File%)

  SELECT CASE File%                       'File Number
    CASE 0: FileName$ = "SPACE2.000"
    CASE 1: FileName$ = "SPACE2.001"
    CASE 2: FileName$ = "SPACE2.002"
    CASE 3: FileName$ = "SPACE2.003"
    CASE 4: FileName$ = "SPACE2.004"
    CASE 5: FileName$ = "SPACE2.005"
    CASE 6: FileName$ = "SPACE2.006"
    CASE 7: FileName$ = "SPACE2.007"
    CASE 8: FileName$ = "SPACE2.008"
    CASE 9: FileName$ = "SPACE2.009"
  END SELECT


  OPEN FileName$ FOR BINARY AS #1         'Check to see if file exists
    Length = LOF(1)                       'Check length
  CLOSE #1

  IF Length = 0 THEN                      'If file dosen't exist
    WaveNumber = 0                        'Wave number is 0
  ELSE                                    'If the file exists
    OPEN FileName$ FOR INPUT AS #1
      INPUT #1, WaveNumber                'Get level number
    CLOSE #1
  END IF
  GetWaveNo% = WaveNumber                 'Return WaveNumber
END FUNCTION

SUB HoldOn (Seconds)
  TTime = TIMER                           'Set Timer
  DO
  LOOP UNTIL TIMER >= TTime + Seconds     'Loop
END SUB

FUNCTION InputText$ (X, Y, Length)
  DIM Edit$(Length)                       'Array to edit
  Ele = 1                                 'First element
  Red = 37                                'Set Colour of Cursor
  DO
    DO                                    'Event loop
      KeyIn = Event                       'Anything happen?
      Red = Red + 1
      IF Red > 40 THEN Red = 37
      Pix5x7Font X + Ele * 6, Y, "_", Red 'Draw cursor

    LOOP UNTIL KeyIn                      'Back for event
      Pix5x7Font X + Ele * 6, Y, "_", 1   'Blank cursor

      SELECT CASE KeyIn                   'Keyboard input

        CASE Enter: EXIT DO               'Enter
        CASE 1 TO 7, 9 TO 126             'Regular keys
          REvent$ = CHR$(KeyIn)           'Convert for printing
          IF Ele < Length THEN            'Stay in bounds.... Print character
            Pix5x7Font X + Ele * 6, Y, CHR$(KeyIn), 15
            Edit$(Ele) = REvent$          'For backspace
            Ele = Ele + 1                 'Adjust Ele.... Draw cursor
            Pix5x7Font X + Ele * 6, Y, "_", Red
          END IF
        CASE 8                            'Backspace
         IF Ele > 1 THEN
           Ele = Ele - 1                  'Adjust
           Edit$(Ele) = CHR$(Space)       'Clear element
           LINE (X + Ele * 6, Y)-STEP(4, 8), 1, BF
         END IF
    END SELECT
  LOOP

  FOR N = 1 TO Length - 1                 'Put elements into a string
    IF Edit$(N) = "" THEN Edit$(N) = CHR$(Space)
    Temp$ = Temp$ + Edit$(N)              'Create string
  NEXT N

  InputText$ = Temp$

END FUNCTION

SUB KeyCheck (Key$)
  SELECT CASE VAL(Key$)                   'Check to see what key was pressed
    CASE Esc, 88, 120: RUN                'Esc, X, x.... S, s
    CASE 83, 115: SoundMode = NOT SoundMode
    CASE 49
      IF Shield >= 1 AND ActivH = False THEN
        CALL OptButton(4, 64, 16, 76, 0, 0)
        SoundFx 6: HoldOn .1
        CALL OptButton(4, 64, 16, 76, 1, 0)
        ActivH = True
        PUT (XMin + 1, 160), Shld, PSET
        Shield = Shield - 1
        Sw = True
        LINE (20, 67)-STEP(18, 10), 0, BF
        Pix5x7Font 20, 67, STR$(Shield), 74
      ELSE
        SoundFx 5
      END IF
    CASE 50
      IF SBomb >= 1 AND ActivB = False THEN
        CALL OptButton(4, 86, 16, 98, 0, 0)
        SoundFx 6: HoldOn .1
        CALL OptButton(4, 86, 16, 98, 1, 0)
        ActiveB = True
        SBomb = SBomb - 1
        Sw = True
        ActivB = True
        LINE (20, 89)-STEP(18, 10), 0, BF
        Pix5x7Font 20, 89, STR$(SBomb), 53
      ELSE
        SoundFx 5
      END IF
    CASE 51
      IF Slow >= 1 AND ActivL = False THEN
        CALL OptButton(4, 108, 16, 120, 0, 0)
        SoundFx 6: HoldOn .1
        CALL OptButton(4, 108, 16, 120, 1, 0)
        Slow = Slow - 1
        ActivL = True
        Sw = True
        Speed! = Speed! * 2
        LINE (20, 111)-STEP(18, 10), 0, BF
        Pix5x7Font 20, 111, STR$(Slow), 15
      ELSE
        SoundFx 5
      END IF
    CASE 52
      IF Fire >= 1 AND ActivF = False THEN
        CALL OptButton(4, 130, 16, 142, 0, 0)
        SoundFx 6: HoldOn .1
        CALL OptButton(4, 130, 16, 142, 1, 0)
        Fire = Fire - 1
        ActivF = True
        GunNo = 21
        Sw = True
        LINE (20, 133)-STEP(18, 10), 0, BF
        Pix5x7Font 20, 133, STR$(Fire), 42
      ELSE
        SoundFx 5
      END IF


  END SELECT
END SUB

SUB KillAlien
  SoundFx 0                               'Draw Correct Beam
  IF GunNo = 1 THEN PUT (GX% + 3, 20), Beam2, XOR
  IF GunNo = 2 THEN PUT (GX% + 1, 23), Beam3, XOR
  IF GunNo = 10 THEN PUT (GX%, 26), Beam10, XOR
  IF GunNo = 21 THEN PUT (GX% - 6, 19), Beam21, XOR
  HoldOn .03                              'Remove Beam
  IF GunNo = 1 THEN PUT (GX% + 3, 20), Beam2
  IF GunNo = 2 THEN PUT (GX% + 1, 23), Beam3
  IF GunNo = 10 THEN PUT (GX%, 26), Beam10
  IF GunNo = 21 THEN PUT (GX% - 6, 19), Beam21
  KillA = False
  SELECT CASE (GX% + 5)
    CASE CH1X% - GunNo TO CH1X% + 5 + GunNo
    IF AlienC1 = True THEN
      PUT (CH1X%, CH1Y%), XPlode, XOR
      HoldOn .001
      AlienC1 = False
      AOS = AOS - 1
      Aliens = Aliens - 1
      SoundFx 1
      KillA = True
      Score& = Score& + 200
      PUT (CH1X%, CH1Y%), XPlode
    END IF
    CASE CH2X% - GunNo TO CH2X% + 5 + GunNo
    IF AlienC2 = True THEN
      PUT (CH2X%, CH2Y%), XPlode, XOR
      HoldOn .001
      AlienC2 = False
      AOS = AOS - 1
      Aliens = Aliens - 1
      SoundFx 1
      KillA = True
      Score& = Score& + 200
      PUT (CH2X%, CH2Y%), XPlode
    END IF
    CASE SWAX% - GunNo TO SWAX% + 8 + GunNo
    IF AlienW = True THEN
      PUT (SWAX%, SWAY%), XPlode, XOR
      HoldOn .001
      AlienW = False
      AOS = AOS - 1
      Aliens = Aliens - 1
      SoundFx 1
      KillA = True
      Score& = Score& + 250
      PUT (SWAX%, SWAY%), XPlode
    END IF
    CASE LBMX% - 1 - GunNo TO LBMX% + 12 + GunNo
    IF AlienL = True THEN
      PUT (LBMX%, LBMY%), XPlode, XOR
      HoldOn .001
      AlienL = False
      AOS = AOS - 1
      Aliens = Aliens - 1
      SoundFx 1
      KillA = True
      Score& = Score& + 500
      PUT (LBMX%, LBMY%), XPlode
    END IF
    CASE NBMX% - 1 - GunNo TO NBMX% + 12 + GunNo
    IF AlienB = True THEN
      PUT (NBMX%, NBMY%), XPlode, XOR
      HoldOn .001
      AlienB = False
      AOS = AOS - 1
      Aliens = Aliens - 1
      SoundFx 1
      KillA = True
      Score& = Score& + 300
      PUT (NBMX%, NBMY%), XPlode
    END IF
  END SELECT

  IF KillA = True THEN
    LINE (10, 10)-STEP(40, 8), 0, BF
    LINE (25, 30)-STEP(15, 18), 0, BF
    Pix5x7Font 10, 10, STR$(Score&), 15
    Pix5x7Font 20, 40, STR$(Aliens), 15
  END IF
END SUB

SUB LoadWave
  DIM TempArea(58, 99)  AS INTEGER        'Array to hold Background
  GET (89, 10)-(147, 109), TempArea       'Get background
  PUT (89, 10), TempArea                  'Remove Background
  LINE (89, 10)-(147, 109), 67, B         'Draw Box
  FOR Lines = 10 TO 90 STEP 8
    LINE (90, Lines)-(146, Lines), 67     'Draw File seporators
  NEXT

  FOR Y = 12 TO 84 STEP 8
    Pix3x5Nums 0, 0, 95, Y, Number, 15, 0 'Write Number of file
    Number = Number + 1
  NEXT

  A = GetWaveNo(0)                        'Get the Wave number from file
  B = GetWaveNo(1)                        'Ditto
  C = GetWaveNo(2)                        'Ditto
  D = GetWaveNo(3)                        'Ditto
  E = GetWaveNo(4)                        'Ditto
  F = GetWaveNo(5)                        'Ditto
  G = GetWaveNo(6)                        'Ditto
  H = GetWaveNo(7)                        'Ditto
  I = GetWaveNo(8)                        'Ditto
  J = GetWaveNo(9)                        'Ditto

  Pix3x5Nums 108, 12, 135, 12, A, 67, 1   'Write Wave Number
  Pix3x5Nums 108, 20, 135, 20, B, 67, 1   'Ditto
  Pix3x5Nums 108, 28, 135, 28, C, 67, 1   'Ditto
  Pix3x5Nums 108, 36, 135, 36, D, 67, 1   'Ditto
  Pix3x5Nums 108, 44, 135, 44, E, 67, 1   'Ditto
  Pix3x5Nums 108, 52, 135, 52, F, 67, 1   'Ditto
  Pix3x5Nums 108, 60, 135, 60, G, 67, 1   'Ditto
  Pix3x5Nums 108, 68, 135, 68, H, 67, 1   'Ditto
  Pix3x5Nums 108, 76, 135, 76, I, 67, 1   'Ditto
  Pix3x5Nums 108, 84, 135, 84, J, 67, 1   'Ditto

  Pix5x7Font 90, 92, "Select File", 67    'Tell user what to do
  Pix5x7Font 109, 101, "0-9", 67

  DO
    SELECT CASE Event                     'Ask user for file number
      CASE 48: L = 0: EXIT DO             'Set file Number
      CASE 49: L = 1: EXIT DO             'Ditto
      CASE 50: L = 2: EXIT DO             'Ditto
      CASE 51: L = 3: EXIT DO             'Ditto
      CASE 52: L = 4: EXIT DO             'Ditto
      CASE 53: L = 5: EXIT DO             'Ditto
      CASE 54: L = 6: EXIT DO             'Ditto
      CASE 55: L = 7: EXIT DO             'Ditto
      CASE 56: L = 8: EXIT DO             'Ditto
      CASE 57: L = 9: EXIT DO             'Ditto
      CASE Esc                            'Exit LoadWave
        PUT (89, 10), TempArea, PSET
        EXIT SUB
    END SELECT
  LOOP

  SELECT CASE L
    CASE 0: FileName$ = "SPACE2.000"      'Open correct file
    CASE 1: FileName$ = "SPACE2.001"      'Ditto
    CASE 2: FileName$ = "SPACE2.002"      'Ditto
    CASE 3: FileName$ = "SPACE2.003"      'Ditto
    CASE 4: FileName$ = "SPACE2.004"      'Ditto
    CASE 5: FileName$ = "SPACE2.005"      'Ditto
    CASE 6: FileName$ = "SPACE2.006"      'Ditto
    CASE 7: FileName$ = "SPACE2.007"      'Ditto
    CASE 8: FileName$ = "SPACE2.008"      'Ditto
    CASE 9: FileName$ = "SPACE2.009"      'Ditto
  END SELECT

  OPEN FileName$ FOR BINARY AS #1
    Length = LOF(1)                       'Check Length
  CLOSE #1

  IF Length = 0 THEN
    PUT (89, 10), TempArea, PSET
    BEEP
    EXIT SUB
  END IF

  OPEN FileName$ FOR INPUT AS #1
    INPUT #1, Wave, Score&, Fire, Shield, SBomb, Slow, Difficulty!, SoundMode!
  CLOSE 1#

  PUT (89, 10), TempArea, PSET
  ERASE TempArea
END SUB

SUB MousePointer (Comm)

POKE VARPTR(Mice(0)) + 1, Comm            'Swap code
CALL ABSOLUTE(C, VARPTR(Mice(0)))         'Run Code

END SUB

SUB MoveAlien
  RemAlien
  IF AlienC1 = True THEN
  IF CH1Y% <= YMax THEN CH1Y% = CH1Y% + 4
    IF CH1X% > GX% THEN CH1X% = CH1X% - 4
    IF CH1X% < GX% THEN CH1X% = CH1X% + 4
    PUT (CH1X%, CH1Y%), Chaser1, PSET

    IF CH1Y% >= 150 AND ActivH = True THEN
      SoundFx 1
      Aliens = Aliens - 1
      AOS = AOS - 1
      PUT (CH1X%, CH1Y%), Chaser1
      DoReset 1, 1
    END IF

    IF CH1Y% >= YMax - 20 AND ActivH = False THEN
      SoundFx 3
      Energy = Energy - 2
      Aliens = Aliens - 1
      AOS = AOS - 1
      PUT (CH1X%, CH1Y%), Chaser1
      DoReset 1, 1
      BackGround 1
    END IF
  END IF
  IF AlienC2 = True THEN
  IF CH2Y% <= YMax THEN CH2Y% = CH2Y% + 4
    IF CH2X% > GX% THEN CH2X% = CH2X% - 4
    IF CH2X% < GX% THEN CH2X% = CH2X% + 4
    PUT (CH2X%, CH2Y%), Chaser2, PSET

    IF CH2Y% >= 150 AND ActivH = True THEN
      SoundFx 1
      Aliens = Aliens - 1
      AOS = AOS - 1
      PUT (CH2X%, CH2Y%), Chaser2
      DoReset 1, 1
    END IF

    IF CH2Y% >= YMax - 20 AND ActivH = False THEN
      SoundFx 3
      Energy = Energy - 2
      Aliens = Aliens - 1
      AOS = AOS - 1
      PUT (CH2X%, CH2Y%), Chaser2
      DoReset 1, 2
      BackGround 1
    END IF
  END IF

  IF AlienW = True THEN
  IF SWAY% <= YMax THEN SWAY% = SWAY% + 8
    IF SWAX% > GX% THEN SWAX% = SWAX% - 8
    IF SWAX% < GX% THEN SWAX% = SWAX% + 8
    PUT (SWAX%, SWAY%), Swarmer, PSET

    IF SWAY% >= 150 AND ActivH = True THEN
      SoundFx 1
      Aliens = Aliens - 1
      AOS = AOS - 1
      PUT (SWAX%, SWAY%), Swarmer
      DoReset 1, 5
    END IF

    IF SWAY% >= YMax - 20 AND ActivH = False THEN
      SoundFx 3
      Energy = Energy - 4
      Aliens = Aliens - 1
      AOS = AOS - 1
      PUT (SWAX%, SWAY%), Swarmer
      DoReset 1, 5
      BackGround 1
    END IF
  END IF

  IF AlienL = True THEN
    IF LBMX% > GX% + 40 THEN LBMX% = LBMX% - 4
    IF LBMX% < XMax - 15 THEN
      IF LBMX% < GX% + 40 THEN LBMX% = LBMX% + 4
    ELSEIF LBMX% > XMax - 15 THEN
      LBMX% = XMax - 15
    END IF
    PUT (LBMX%, LBMY%), LBomb, PSET

    IF LBMX% >= GX% + 36 AND LBMX% <= GX% + 44 THEN
      PUT (LBMX% - 40, LBMY% + 15), Lightening, XOR
      HoldOn .1
      SoundFx 4
      PUT (LBMX% - 40, LBMY% + 15), Lightening
      IF LBMX% >= GX% + 36 AND LBMX% <= GX% + 44 AND ActivH = False THEN
        SoundFx 3
        Energy = Energy - 25
        PUT (LBMX%, LBMY%), LBomb
        Aliens = Aliens - 1
        AOS = AOS - 1
        DoReset 1, 4
        BackGround 1
      END IF
    END IF
  END IF
  IF AlienB = True THEN
    IF NBMX% > GX% THEN NBMX% = NBMX% - 4
    IF NBMX% < XMax - 18 THEN
      IF NBMX% < GX% THEN NBMX% = NBMX% + 4
    ELSEIF NBMX% >= XMax - 17 THEN
      NBMX% = NBMX% - 1
    END IF
    PUT (NBMX%, NBMY%), NBomb, PSET

    IF NBMX% >= GX% - 2 AND NBMX% <= GX% + 4 THEN
      PUT (NBMX% + 4, NBMY% + 12), BombLaser, XOR
      HoldOn .1
      SoundFx 4
      PUT (NBMX% + 4, NBMY% + 12), BombLaser
      IF NBMX% >= GX% - 1 AND NBMX% <= GX% + 2 AND ActivH = False THEN
        SoundFx 3
        Energy = Energy - 10
        PUT (NBMX%, NBMY%), NBomb
        Aliens = Aliens - 1
        AOS = AOS - 1
        DoReset 1, 3
        BackGround 1
      END IF
    END IF
  END IF

END SUB

SUB OptButton (X1, Y1, X2, Y2, IO, Fill)
  IF Fill THEN LINE (X1 + 1, Y1 + 2)-(X2 - 1, Y2 - 1), 1, BF
  SELECT CASE IO
  CASE 0
    LINE (X1, Y1)-(X2, Y1), 104
    LINE (X1 + 1, Y1 + 1)-(X2 - 1, Y1 + 1), 104
    LINE (X2 + 1, Y1)-(X2 + 1, Y2), 104
    LINE (X2, Y1)-(X2, Y2 - 1), 104
    LINE (X1 + 1, Y2)-(X2, Y2), 32
    LINE (X1, Y2 + 1)-(X2 + 1, Y2 + 1), 32
    LINE (X1 - 1, Y1)-(X1 - 1, Y2 + 1), 32
    LINE (X1, Y1 + 1)-(X1, Y2), 32
    EXIT SUB

  CASE 1
    LINE (X1, Y1)-(X2, Y1), 32
    LINE (X1 + 1, Y1 + 1)-(X2 - 1, Y1 + 1), 32
    LINE (X2 + 1, Y1)-(X2 + 1, Y2), 32
    LINE (X2, Y1)-(X2, Y2 - 1), 32
    LINE (X1 + 1, Y2)-(X2, Y2), 104
    LINE (X1, Y2 + 1)-(X2 + 1, Y2 + 1), 104
    LINE (X1 - 1, Y1)-(X1 - 1, Y2 + 1), 104
    LINE (X1, Y1 + 1)-(X1, Y2), 104
    EXIT SUB
  END SELECT

END SUB

SUB Options
  DIM MouseHead(10, 9) AS INTEGER
  DRAW "bm1,1c40d8e3r3h6bd3brp40,40"
  GET (0, 0)-(10, 9), MouseHead
  DO
    DO
      TempX% = X%: TempY% = Y%
      CALL OptMouse(Y%, X%, Button%)
    LOOP UNTIL Button% = 1 OR Button% = 2 OR TempX% <> X% OR TempY% <> Y%
    PUT (TempX%, TempY%), MouseHead
    PUT (X%, Y%), MouseHead, XOR
    SELECT CASE Button%
      CASE 2: EXIT DO
      CASE 1
        SELECT CASE Y%
          CASE 64 TO 76
            IF X% >= 4 AND X% <= 16 THEN
              IF Shield >= 1 AND ActivH = False THEN
                CALL OptButton(4, 64, 16, 76, 0, 0)
                SoundFx 6: HoldOn .1
                CALL OptButton(4, 64, 16, 76, 1, 0)
                ActivH = True
                PUT (XMin + 1, 160), Shld, PSET
                Shield = Shield - 1
                Sw = True
                LINE (20, 67)-STEP(18, 10), 0, BF
                Pix5x7Font 20, 67, STR$(Shield), 74
              ELSE
                SoundFx 5
              END IF
            END IF
          CASE 86 TO 98
            IF X% >= 4 AND X% <= 16 THEN
              IF SBomb >= 1 AND ActivB = False THEN
                CALL OptButton(4, 86, 16, 98, 0, 0)
                SoundFx 6: HoldOn .1
                CALL OptButton(4, 86, 16, 98, 1, 0)
                ActiveB = True
                SBomb = SBomb - 1
                Sw = True
                ActivB = True
                LINE (20, 89)-STEP(18, 10), 0, BF
                Pix5x7Font 20, 89, STR$(SBomb), 53
              ELSE
                SoundFx 5
              END IF
            END IF
          CASE 108 TO 120
            IF X% >= 4 AND X% <= 16 THEN
              IF Slow >= 1 AND ActivL = False THEN
                CALL OptButton(4, 108, 16, 120, 0, 0)
                SoundFx 6: HoldOn .1
                CALL OptButton(4, 108, 16, 120, 1, 0)
                Slow = Slow - 1
                ActivL = True
                Sw = True
                Speed! = Speed! * 2
                LINE (20, 111)-STEP(18, 10), 0, BF
                Pix5x7Font 20, 111, STR$(Slow), 15
              ELSE
                SoundFx 5
              END IF
            END IF
          CASE 130 TO 142
            IF X% >= 4 AND X% <= 16 THEN
              IF Fire >= 1 AND ActivF = False THEN
                CALL OptButton(4, 130, 16, 142, 0, 0)
                SoundFx 6: HoldOn .1
                CALL OptButton(4, 130, 16, 142, 1, 0)
                Fire = Fire - 1
                ActivF = True
                GunNo = 21
                Sw = True
                LINE (20, 133)-STEP(18, 10), 0, BF
                Pix5x7Font 20, 133, STR$(Fire), 42
              ELSE
                SoundFx 5
              END IF
            END IF
          CASE 150 TO 162
            IF X% >= 4 AND X% <= 32 THEN
              CALL OptButton(4, 150, 32, 162, 0, 0)
              SoundFx 6: HoldOn .2
              CALL OptButton(4, 150, 32, 162, 1, 0)
              SaveWave
            END IF
          CASE 170 TO 182
            IF X% >= 4 AND X% <= 32 THEN
              CALL OptButton(4, 169, 32, 181, 0, 0)
              SoundFx 6: HoldOn .2
              CALL OptButton(4, 169, 32, 181, 1, 0)
              END
            END IF
          CASE ELSE: SoundFx 5
        END SELECT
    END SELECT
  LOOP
  PUT (X%, Y%), MouseHead
END SUB

SUB OptionScreen
  OPEN "SPACE2.OPT" FOR INPUT AS #1
    INPUT #1, SoundMode!, Difficulty!
  CLOSE #1

  CALL OptButton(70, 130, 98, 142, 1, 1)
  Pix5x7Font 73, 133, "Load", 15

  CALL OptButton(225, 130, 253, 142, 1, 1)
  Pix5x7Font 228, 133, "Help", 15

  CALL OptButton(80, 30, 240, 70, 1, 1)
  Pix5x7Font 105, 48, "PLAY SPACE FIGHTER", 0
  Pix5x7Font 107, 50, "PLAY SPACE FIGHTER", 15

  CALL OptButton(14, 165, 42, 185, 1, 1)
  Pix5x7Font 17, 168, "Exit", 15
  Pix5x7Font 17, 177, "Game", 15

  Pix5x7Font 20, 38, "Sound", 0
  Pix5x7Font 22, 40, "Sound", 15
  SELECT CASE SoundMode!
    CASE -1
      CALL OptButton(24, 55, 46, 66, 0, 1)
      CALL OptButton(24, 70, 46, 81, 1, 1)
    CASE 0
      CALL OptButton(24, 55, 46, 66, 1, 1)
      CALL OptButton(24, 70, 46, 81, 0, 1)
    CASE ELSE: CALL Errors(1)
  END SELECT
  Pix5x7Font 29, 58, "On", 46
  Pix5x7Font 27, 73, "Off", 40

  Pix5x7Font 249, 38, "Difficulty", 0
  Pix5x7Font 251, 40, "Difficulty", 15
  SELECT CASE Difficulty!
    CASE 1.2
      CALL OptButton(260, 55, 288, 66, 0, 1)
      CALL OptButton(260, 70, 288, 81, 1, 1)
      CALL OptButton(260, 85, 288, 97, 1, 1)
      Shield = 5: SBomb = 5
      Slow = 5: Fire = 5
    CASE 1
      CALL OptButton(260, 55, 288, 66, 1, 1)
      CALL OptButton(260, 70, 288, 81, 0, 1)
      CALL OptButton(260, 85, 288, 97, 1, 1)
      Shield = 3: SBomb = 3
      Slow = 3: Fire = 3
    CASE .5
      CALL OptButton(260, 55, 288, 66, 1, 1)
      CALL OptButton(260, 70, 288, 81, 1, 1)
      CALL OptButton(260, 85, 288, 97, 0, 1)
      Shield = 0: SBomb = 0
      Slow = 0: Fire = 0
    CASE ELSE: CALL Errors(1)
  END SELECT
  Pix5x7Font 266, 58, "Low", 46
  Pix5x7Font 266, 73, "Med", 15
  Pix5x7Font 263, 88, "High", 40

  DIM MouseHead(10, 9) AS INTEGER
  DRAW "bm1,1c40d8e3r3h6bd3brp40,40"
  GET (0, 0)-(10, 9), MouseHead

  CALL MousePointer(0)              'Reset mouse
  CALL MousePointer(3)              'Get coordinates

  DO
    DO
      TempX% = X%: TempY% = Y%

      CALL OptMouse(Y%, X%, Button%)
      LOOP UNTIL Button% = 1 OR Button% = 2 OR TempX% <> X% OR TempY% <> Y%
    PUT (TempX%, TempY%), MouseHead
    PUT (X%, Y%), MouseHead, XOR

    IF Button% = 1 THEN
      IF X% >= 80 AND X% <= 240 AND Y% >= 30 AND Y% <= 70 THEN
        CALL OptButton(80, 30, 240, 70, 0, 0)
        SoundFx 6: HoldOn .1
        CALL OptButton(80, 30, 240, 70, 1, 0)
        EXIT DO
      END IF

      IF X% >= 14 AND X% <= 42 AND Y% >= 170 AND Y% <= 190 THEN
        CALL OptButton(14, 165, 42, 185, 0, 0)
        SoundFx 6: HoldOn .1
        CALL OptButton(14, 165, 42, 185, 1, 0)
        END
      END IF

      IF X% >= 24 AND X% <= 46 AND Y% >= 55 AND Y% <= 66 THEN
        SoundMode! = -1
        SoundFx 6
        CALL OptButton(24, 55, 46, 66, 0, 0)
        CALL OptButton(24, 70, 46, 81, 1, 0)
      END IF

      IF X% >= 24 AND X% <= 46 AND Y% >= 70 AND Y% <= 81 THEN
        SoundMode! = 0
        SoundFx 6
        CALL OptButton(24, 55, 46, 66, 1, 0)
        CALL OptButton(24, 70, 46, 81, 0, 0)
      END IF
      IF X% >= 260 AND X% <= 288 AND Y% >= 55 AND Y% <= 66 THEN
        Difficulty! = 1.2
        SoundFx 6
        CALL OptButton(260, 55, 288, 66, 0, 0)
        CALL OptButton(260, 70, 288, 81, 1, 0)
        CALL OptButton(260, 85, 288, 97, 1, 0)
        Shield = 5: SBomb = 5
        Slow = 5: Fire = 5
      END IF
      IF X% >= 260 AND X% <= 288 AND Y% >= 70 AND Y% <= 81 THEN
        Difficulty! = 1
        SoundFx 6
        CALL OptButton(260, 55, 288, 66, 1, 0)
        CALL OptButton(260, 70, 288, 81, 0, 0)
        CALL OptButton(260, 85, 288, 97, 1, 0)
        Shield = 3: SBomb = 3
        Slow = 3: Fire = 3
      END IF
      IF X% >= 260 AND X% <= 288 AND Y% >= 85 AND Y% <= 97 THEN
        Difficulty! = .5
        SoundFx 6
        CALL OptButton(260, 55, 288, 66, 1, 0)
        CALL OptButton(260, 70, 288, 81, 1, 0)
        CALL OptButton(260, 85, 288, 97, 0, 0)
        Shield = 0: SBomb = 0
        Slow = 0: Fire = 0
      END IF
      IF X% >= 70 AND X% <= 98 AND Y% >= 130 AND Y% <= 142 THEN
        CALL OptButton(70, 130, 98, 142, 0, 0)
        SoundFx 6: HoldOn .1
        CALL OptButton(70, 130, 98, 142, 1, 0)
        LoadWave
        HoldOn 1
        EXIT DO
      END IF
      IF X% >= 225 AND X% <= 253 AND Y% >= 130 AND Y% <= 142 THEN
        CALL OptButton(225, 130, 253, 142, 0, 0)
        SoundFx 6: HoldOn .1
        CALL OptButton(225, 130, 253, 142, 1, 0)
        CHAIN "HELP.BAS"
      END IF
    END IF
  LOOP

  OPEN "SPACE2.OPT" FOR OUTPUT AS #1
    WRITE #1, SoundMode!, Difficulty!
  CLOSE #1

END SUB

SUB OptMouse (Y%, X%, Button%)
  POKE VARPTR(Mice(4)), &H92              'Swap code, Get Y% setup
  CALL ABSOLUTE(Y%, VARPTR(Mice(0)))      'Run Code
  IF Y% > YMax - 5 THEN Y% = YMax - 5
  POKE VARPTR(Mice(4)), &H91              'Swap code, Get X% setup
  CALL ABSOLUTE(X%, VARPTR(Mice(0)))      'Run Code
  X% = X% / 2
  IF X% > XMax - 11 THEN X% = XMax - 11
  POKE VARPTR(Mice(4)), &H93              'Swap code, Get Button% setup
  CALL ABSOLUTE(Button%, VARPTR(Mice(0))) 'Run Code

END SUB

SUB Pix3x5Nums (WX, WY, PX, PY, Num, Colour, Title)

  IF Title THEN                           'Need Title?

  FOR PartY = 0 TO 4                      'Top to Bottom
    FOR PartX = 0 TO 20                   'Left to Right
      IF WaveFile(PartX, PartY) = 1 THEN  'Set Pix only.... Draw Pix
        PSET (WX + PartX, WY + PartY), Colour
      END IF
    NEXT
  NEXT
  END IF

  Num$ = LTRIM$(STR$(Num))                'Convert Number to a String
  Length = LEN(Num$)
  IF Length = 0 THEN EXIT SUB             'Check length of String

  FOR Char = 0 TO Length - 1              'Print loop

    Piece$ = MID$(Num$, Char + 1, 1)      'Look at each piece of string

    FOR PartY = 0 TO 4                    'Top to Bottom
      FOR PartX = 0 TO 2                  'Left to right.... Set Pix only
        IF Nums(VAL(Piece$), PartX, PartY) = 1 THEN
          PSET (PX + PartX + MoveX, PY + PartY), Colour
        END IF
      NEXT
    NEXT

    MoveX = MoveX + 4                     'Increase X Axis
  NEXT

END SUB

SUB Pix5x7Font (PX, PY, Text$, Colour)

  Length = LEN(Text$)                     'Check length
  IF Length = 0 THEN EXIT SUB

  FOR Char = 0 TO Length - 1              'Print loop

    Piece$ = MID$(Text$, Char + 1, 1)     'Look at each piece of string
    Ascii = ASC(Piece$)                   'Get ASCII value

    SELECT CASE Piece$                    'Y Axis
      CASE "g": MoveY = MoveY + 2         'Ditto
      CASE "j": MoveY = MoveY + 2         'Ditto
      CASE "p": MoveY = MoveY + 2         'Ditto
      CASE "q": MoveY = MoveY + 2         'Ditto
      CASE "y": MoveY = MoveY + 2         'Ditto
    END SELECT

    FOR PartY = 0 TO 6                    'Top to Bottom
      FOR PartX = 0 TO 4                  'Left to right.... Set Pix only
        IF Font(Ascii, PartX, PartY) = 1 THEN
          PSET (PX + PartX + MoveX, PY + PartY + MoveY), Colour
        END IF
      NEXT
    NEXT

    SELECT CASE Piece$                    'X Axis
      CASE "i": MoveX = MoveX + 4         'Ditto
      CASE "j": MoveX = MoveX + 5         'Ditto
      CASE "l": MoveX = MoveX + 3         'Ditto
      CASE "r": MoveX = MoveX + 5         'Ditto
      CASE ".": MoveX = MoveX + 3         'Ditto
      CASE "(": MoveX = MoveX + 3         'Ditto
      CASE ")": MoveX = MoveX + 3         'Ditto
      CASE "'": MoveX = MoveX + 2         'Ditto
      CASE "!": MoveX = MoveX + 2         'Ditto
      CASE ELSE: MoveX = MoveX + 6        'Ditto
    END SELECT

    MoveY = 0                             'Reset Y Axis
  NEXT
END SUB

SUB RemAlien
  IF AlienC1 = True THEN PUT (CH1X%, CH1Y%), Chaser1
  IF AlienC2 = True THEN PUT (CH2X%, CH2Y%), Chaser2
  IF AlienL = True THEN PUT (LBMX%, LBMY%), LBomb
  IF AlienB = True THEN PUT (NBMX%, NBMY%), NBomb
  IF AlienW = True THEN PUT (SWAX%, SWAY%), Swarmer
END SUB

SUB SaveWave
  DIM TempArea(58, 99)  AS INTEGER
  GET (89, 10)-(147, 109), TempArea
  PUT (89, 10), TempArea
  LINE (89, 10)-(147, 109), 67, B
  FOR Lines = 10 TO 90 STEP 8
    LINE (90, Lines)-(146, Lines), 67
  NEXT

  FOR Y = 12 TO 84 STEP 8
    Pix3x5Nums 0, 0, 95, Y, Number, 15, 0
    Number = Number + 1
  NEXT


  A = GetWaveNo(0)
  B = GetWaveNo(1)
  C = GetWaveNo(2)
  D = GetWaveNo(3)
  E = GetWaveNo(4)
  F = GetWaveNo(5)
  G = GetWaveNo(6)
  H = GetWaveNo(7)
  I = GetWaveNo(8)
  J = GetWaveNo(9)

  Pix3x5Nums 108, 12, 135, 12, A, 67, 1
  Pix3x5Nums 108, 20, 135, 20, B, 67, 1
  Pix3x5Nums 108, 28, 135, 28, C, 67, 1
  Pix3x5Nums 108, 36, 135, 36, D, 67, 1
  Pix3x5Nums 108, 44, 135, 44, E, 67, 1
  Pix3x5Nums 108, 52, 135, 52, F, 67, 1
  Pix3x5Nums 108, 60, 135, 60, G, 67, 1
  Pix3x5Nums 108, 68, 135, 68, H, 67, 1
  Pix3x5Nums 108, 76, 135, 76, I, 67, 1
  Pix3x5Nums 108, 84, 135, 84, J, 67, 1

  Pix5x7Font 90, 92, "Select File", 67
  Pix5x7Font 109, 101, "0-9", 67

  DO
    SELECT CASE Event                     'Ask user for file number
      CASE 48: L = 0: EXIT DO
      CASE 49: L = 1: EXIT DO
      CASE 50: L = 2: EXIT DO
      CASE 51: L = 3: EXIT DO
      CASE 52: L = 4: EXIT DO
      CASE 53: L = 5: EXIT DO
      CASE 54: L = 6: EXIT DO
      CASE 55: L = 7: EXIT DO
      CASE 56: L = 8: EXIT DO
      CASE 57: L = 9: EXIT DO
      CASE Esc
        PUT (89, 10), TempArea, PSET
        EXIT SUB
    END SELECT
  LOOP

  SELECT CASE L
    CASE 0: FileName$ = "SPACE2.000"
    CASE 1: FileName$ = "SPACE2.001"
    CASE 2: FileName$ = "SPACE2.002"
    CASE 3: FileName$ = "SPACE2.003"
    CASE 4: FileName$ = "SPACE2.004"
    CASE 5: FileName$ = "SPACE2.005"
    CASE 6: FileName$ = "SPACE2.006"
    CASE 7: FileName$ = "SPACE2.007"
    CASE 8: FileName$ = "SPACE2.008"
    CASE 9: FileName$ = "SPACE2.009"
  END SELECT


  OPEN FileName$ FOR OUTPUT AS #1
    WRITE #1, Wave, Score&, Fire, Shield, SBomb, Slow, Difficulty!, SoundMode!
  CLOSE 1#

  PUT (89, 10), TempArea, PSET
  ERASE TempArea
END SUB

SUB Setup
  DIM DrawData(1 TO 17) AS STRING

  OPEN "SPACE2.DAT" FOR RANDOM AS #1
    FOR I = 1 TO 17
      GET #1, I, DrawData(I)
    NEXT
  CLOSE #1
  DRAW "X" + VARPTR$(DrawData(1))
  GET (0, 0)-(4, 168), Beam2
  PUT (0, 0), Beam2

  DRAW "X" + VARPTR$(DrawData(2))
  DRAW "X" + VARPTR$(DrawData(3))
  GET (0, 0)-(8, 166), Beam3
  PUT (0, 0), Beam3

  DRAW "bm1,160c63e8h8e8h8e8h8e8h8e8h8e8h8e8h8e8h8e8h8e8h8"
  DRAW "br8g8f8g8f8g8f8g8f8g8f8g8f8g8f8g8f8g8f8g8f8"
  DRAW "bl4c53u160l5d160r10u160l8"
  GET (0, 0)-(10, 160), Beam10
  PUT (0, 0), Beam10

  DRAW "X" + VARPTR$(DrawData(4))
  DRAW "X" + VARPTR$(DrawData(5))
  DRAW "X" + VARPTR$(DrawData(6))
  DRAW "X" + VARPTR$(DrawData(7))
  GET (0, 0)-(21, 169), Beam21
  PUT (0, 0), Beam21

  DRAW "X" + VARPTR$(DrawData(8))
  GET (0, 0)-(10, 6), Gun
  PUT (0, 0), Gun

  DRAW "X" + VARPTR$(DrawData(9))
  GET (0, 0)-(8, 14), Chaser1
  PUT (0, 0), Chaser1

  DRAW "X" + VARPTR$(DrawData(10))
  GET (0, 0)-(5, 14), Chaser2
  PUT (0, 0), Chaser2

  CIRCLE (8, 8), 7, 5
  DRAW "X" + VARPTR$(DrawData(11))
  GET (0, 0)-(15, 17), LBomb
  PUT (0, 0), LBomb

  CIRCLE (8, 4), 8, 1, , , .4
  DRAW "X" + VARPTR$(DrawData(12))
  GET (0, 0)-(17, 13), NBomb
  PUT (0, 0), NBomb

  DRAW "X" + VARPTR$(DrawData(13))
  DRAW "X" + VARPTR$(DrawData(14))
  DRAW "X" + VARPTR$(DrawData(15))
  GET (0, 0)-(40, 151), Lightening
  PUT (0, 0), Lightening

  DRAW "X" + VARPTR$(DrawData(16))
  GET (0, 0)-(7, 138), BombLaser
  PUT (0, 0), BombLaser

  DRAW "X" + VARPTR$(DrawData(17))
  GET (0, 0)-(253, 9), Shld
  PUT (0, 0), Shld

  CIRCLE (8, 7), 8, 43: PAINT STEP(0, 0), 43, 43
  CIRCLE STEP(0, 0), 5, 42: PAINT STEP(0, 0), 42, 42
  CIRCLE STEP(0, 0), 2, 40: PAINT STEP(0, 0), 40, 40
  GET (0, 0)-(16, 14), XPlode
  PUT (0, 0), XPlode


  CIRCLE (4, 4), 4, 104: PAINT STEP(0, 0), 104, 104
  DRAW "bm0,0c32br4d8bu4bl4r8"
  GET (0, 0)-(8, 8), Swarmer
  PUT (0, 0), Swarmer
END SUB

SUB ShowHighScores (Mode, TileNo)
  TileBackGround (TileNo)

  IF Mode = 1 THEN                        'Need Data?
    OPEN "SPACE2.SCR" FOR RANDOM AS #1    'Open .SCR FIle
      FOR Num = 1 TO 10                   'Count Data
        GET #1, Num, HighScores(Num)      'Get Data
      NEXT
    CLOSE #1                              'Close .SCR
  END IF
                                          'Set X Axis
 X1 = 27: X2 = 50: X3 = 140: X4 = 235: X5 = 277
  Num = 1                                 'Set Scores Num

  Pix5x7Font 59, 30, " SPACE  FIGHTER  2   HALL  OF  FAME", 0
  Pix5x7Font 60, 31, " SPACE  FIGHTER  2   HALL  OF  FAME", 15                 'Titles
  Pix5x7Font 0, 45, "   RANK   DATE          NAME          WAVE   SCORE", 0
  Pix5x7Font 1, 46, "   RANK   DATE          NAME          WAVE   SCORE", 15

  FOR Y = 58 TO 157 STEP 10               'Count Y
    Temp1 = LEN(STR$(HighScores(Num).Ran))
    Temp3 = LEN(RTRIM$(HighScores(Num).Nam))
    Temp4 = LEN(STR$(HighScores(Num).Wav))
    Temp5 = LEN(STR$(HighScores(Num).Scr))
    Pix5x7Font X1 - 1 - (2 * Temp1), Y - 1, STR$(HighScores(Num).Ran), 0
    Pix5x7Font X1 - (2 * Temp1), Y, STR$(HighScores(Num).Ran), 15

    Pix5x7Font X2 - 1, Y - 1, HighScores(Num).Dat, 0
    Pix5x7Font X2, Y, HighScores(Num).Dat, 15

    Pix5x7Font X3 + 9 - (2 * Temp3), Y - 1, HighScores(Num).Nam, 0
    Pix5x7Font X3 + 10 - (2 * Temp3), Y, HighScores(Num).Nam, 15

    Pix5x7Font X4 - 1 - (2 * Temp4) + SGN(2 - Temp4), Y - 1, STR$(HighScores(Num).Wav), 0
    Pix5x7Font X4 - (2 * Temp4) + SGN(2 - Temp4), Y, STR$(HighScores(Num).Wav), 15

    Pix5x7Font X5 - 1 - (2 * Temp5), Y - 1, STR$(HighScores(Num).Scr), 0
    Pix5x7Font X5 - (2 * Temp5), Y, STR$(HighScores(Num).Scr), 15

    Num = Num + 1                         'Increase number
  NEXT

  IF Mode = 1 THEN                        'To Hold
    DO: LOOP UNTIL Event
  END IF

END SUB

SUB SoundFx (Fx%)
  IF SoundMode! = 0 THEN EXIT SUB
  SELECT CASE Fx%

    CASE 0                                'Laser
      Freq = 147
      FOR Scale = 6 TO 1 STEP -1
        Duration = Scale / 100
        Freq = Freq + 47
        SOUND Freq, Duration
      NEXT

    CASE 1                                'Alien Die
      FOR Freq = 400 TO 200 STEP -10
        SOUND Freq, .1
      NEXT

    CASE 2                                'Player Die
      FOR FreqA = 500 TO 100 STEP -10
        SOUND FreqA, .21
        HoldOn .002
      NEXT
      FOR FreqB = 500 TO 100 STEP -10
        SOUND FreqB, .22
        HoldOn .002
      NEXT
    CASE 3                                'Alien Fire
      FOR Freq = 400 TO 100 STEP -10
        SOUND Freq, .2
      NEXT
    CASE 4                                'Player Hurt
      FOR Freq = 500 TO 200 STEP -20
        SOUND Freq, .3
      NEXT
    CASE 5                                'Event Leave
      SOUND 1000, .1
      HoldOn .1
      SOUND 2000, .1
    CASE 6                                'Event Accept
      SOUND 2000, .1
      HoldOn .1
      SOUND 1000, .1
    CASE 7
      SOUND 900, .1
  END SELECT
END SUB

SUB SwBomb
  FOR I = 10 TO 90 STEP 5                 'Number of times
    CIRCLE (170, 100), I, 39              'Draw Circle
    HoldOn .08                            'Wait
    SoundFx 7                             'Sound Explosion
    CIRCLE (170, 100), I, 0               'Remove Circle
  NEXT
  ActivB = False                          'Not using Bomb any more
  IF AlienC1 = True THEN                  'Kill Aliens
    SoundFx 1: Aliens = Aliens - 1
    AOS = AOS - 1: AlienC1 = False
  END IF
  IF AlienC2 = True THEN
    SoundFx 1: Aliens = Aliens - 1
    AOS = AOS - 1: AlienC2 = False
  END IF
  IF AlienL = True THEN
    SoundFx 1: Aliens = Aliens - 1
    AOS = AOS - 1: AlienL = False
  END IF
  IF AlienB = True THEN
    SoundFx 1: Aliens = Aliens - 1
    AOS = AOS - 1: AlienB = False
  END IF
  DoReset 0, 0                            'Total Reset

END SUB

SUB TileBackGround (Number!)
  DIM Tile(20, 10)
  DIM Fill(20, 10)
  DEF SEG = VARSEG(Tile(0, 0))
  SELECT CASE Number!
    CASE 0: FileName$ = "SPACE2.TL0"
    CASE 1: FileName$ = "SPACE2.TL1"
    CASE 2: FileName$ = "SPACE2.TL2"
    CASE 3: FileName$ = "SPACE2.TL3"
    CASE 4: FileName$ = "SPACE2.TL4"
    CASE 5: FileName$ = "SPACE2.TL5"
    CASE 6: FileName$ = "SPACE2.TL6"
    CASE 7: FileName$ = "SPACE2.TL7"
    CASE 8: FileName$ = "SPACE2.TL8"
    CASE 9: FileName$ = "SPACE2.TL9"
  END SELECT

  BLOAD FileName$, 0


  FOR Y = 0 TO 9
    FOR X = 0 TO 19
     PSET (X + 10, Y + 10), Tile(X, Y)
    NEXT
  NEXT

  GET (10, 10)-STEP(20, 10), Fill

  FOR Y = 10 TO 180 STEP 10
    FOR X = 10 TO 300 STEP 20
      PUT (X, Y), Fill, PSET
    NEXT
  NEXT

ERASE Tile
ERASE Fill
END SUB

SUB TitleScreen
  DIM DrawData(20 TO 33) AS STRING

  OPEN "SPACE2.DAT" FOR RANDOM AS #1
    FOR H = 20 TO 33
      GET #1, H, DrawData(H)
    NEXT
  CLOSE #1

  DRAW "X" + VARPTR$(DrawData(20))
  PAINT (2, 103), 176, 14: PAINT (12, 92), 176, 14
  PAINT (25, 92), 176, 14: PAINT (32, 82), 176, 14
  PAINT (24, 83), 176, 14: PAINT (36, 82), 176, 14

  DRAW "X" + VARPTR$(DrawData(21))
  PAINT (29, 102), 176, 14: PAINT (33, 101), 176, 14
  PAINT (46, 93), 176, 14: PAINT (54, 90), 176, 14

  DRAW "X" + VARPTR$(DrawData(22))
  PAINT (52, 102), 176, 14: PAINT (56, 102), 176, 14
  PAINT (62, 102), 176, 14: PAINT (66, 100), 176, 14

  DRAW "X" + VARPTR$(DrawData(23))
  PAINT (84, 102), 176, 14: PAINT (92, 100), 176, 14
  PAINT (92, 90), 176, 14: PAINT (107, 83), 176, 14
  PAINT (111, 81), 176, 14

  DRAW "X" + VARPTR$(DrawData(24))
  PAINT (114, 102), 176, 14: PAINT (116, 101), 176, 14
  PAINT (122, 93), 176, 14: PAINT (128, 90), 176, 14
  PAINT (128, 83), 176, 14: PAINT (136, 81), 176, 14

  DRAW "X" + VARPTR$(DrawData(25))
  PAINT (143, 102), 176, 14: PAINT (146, 101), 176, 14
  PAINT (163, 91), 176, 14: PAINT (166, 90), 176, 14
  PAINT (173, 81), 176, 14: PAINT (176, 81), 176, 14

  DRAW "X" + VARPTR$(DrawData(26))
  PAINT (169, 101), 176, 14: PAINT (172, 100), 176, 14

  DRAW "X" + VARPTR$(DrawData(27))
  PAINT (183, 102), 176, 14: PAINT (197, 100), 176, 14
  PAINT (197, 90), 176, 14: PAINT (208, 83), 176, 14
  PAINT (218, 80), 176, 14

  DRAW "X" + VARPTR$(DrawData(28))
  PAINT (207, 103), 176, 14: PAINT (211, 102), 176, 14
  PAINT (217, 103), 176, 14: PAINT (222, 102), 176, 14
  PAINT (233, 80), 176, 14

  DRAW "X" + VARPTR$(DrawData(29))
  PAINT (237, 103), 176, 14: PAINT (242, 100), 176, 14
  PAINT (252, 82), 176, 14: PAINT (262, 82), 176, 14
  PAINT (267, 80), 176, 14

  DRAW "X" + VARPTR$(DrawData(30))
  PAINT (269, 102), 176, 14: PAINT (271, 101), 176, 14
  PAINT (277, 93), 176, 14: PAINT (283, 90), 176, 14
  PAINT (283, 83), 176, 14: PAINT (291, 81), 176, 14

  DRAW "X" + VARPTR$(DrawData(31))
  PAINT (283, 103), 176, 14: PAINT (286, 101), 176, 14
  PAINT (297, 100), 176, 14: PAINT (301, 103), 176, 14
  PAINT (303, 92), 176, 14: PAINT (306, 91), 176, 14

  Pix5x7Font 80, 130, DrawData(32), 68
  Pix5x7Font 30, 150, DrawData(33), 55

  ERASE DrawData
  FOR I = 46 TO 76
    PAINT (3, 99), I, 14: PAINT (29, 99), I, 14
    PAINT (53, 99), I, 14: PAINT (78, 99), I, 14
    PAINT (103, 99), I, 14: PAINT (143, 99), I, 14
    PAINT (168, 99), I, 14: PAINT (183, 99), I, 14
    PAINT (208, 99), I, 14: PAINT (238, 99), I, 14
    PAINT (258, 99), I, 14: PAINT (283, 99), I, 14
    HoldOn .0001
    IF I = 76 THEN I = 46
    IF Event THEN EXIT FOR
  NEXT
  CLS
END SUB

